import { Injectable } from '@angular/core';

@Injectable()
export class BrowserStorageService {

  private storage: Storage;
  private namespace: string;
  constructor() {
    this.storage = localStorage;
    this.namespace = 'default';
  }

  setNamespace(namespace: string) {
    this.namespace = namespace;
  }

  getNamespace(namespace: string | null = null): string {
    return namespace ?? this.namespace;
  }

  setItem(key: string, value: any, namespace: string | null = null) {
    namespace = this.getNamespace(namespace);
    const path = `${namespace}.${key}`;
    this.storage.setItem(path, JSON.stringify(value));
  }

  getItem(key: string, namespace: string | null = null): any {
    namespace = this.getNamespace(namespace);
    const path = `${namespace}.${key}`;
    return JSON.parse(this.storage.getItem(path) ?? 'null');
  }

  getItemOrDefault(key: string, defaultValue: any, namespace: string | null = null): any {
    return this.getItem(key, namespace) ?? defaultValue;
  }

}
